﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TCCInvoice
{
    internal class Program
    {
        static void Main(string[] args)
        {
            // 建立InvoiceGenerator類別的物件
            InvoiceGenerator myInvoice = new InvoiceGenerator(1);

            // 註冊發票號碼已處理完畢的事件通知
            myInvoice.InvoiceCompleted += MyInvoice_InvoiceCompleted;
            
            // 填具待開立發票的相關資料(Preinvoice)
            myInvoice.DataNumber = "202202201145";
            myInvoice.DataDate = DateTime.Today;
            myInvoice.BuyerId = null; // 一般消費者
            myInvoice.TotalAmount = 524;
            myInvoice.CarrierId1 = null;
            myInvoice.MainRemark = "交易訂單號：1234567888";
            myInvoice.DonateMark = 0;
            myInvoice.ContactEmail = null;
            myInvoice.ContactPhone = null;
            myInvoice.AddInvoiceItem(0, "充電服務費", 41.5793, "度", 12, 499, "充電服務費每度12元");
            myInvoice.AddInvoiceItem(1, "占用費", 30, "分鐘", 50, 25, "占用費每小時50元");
            // 開立發票
            myInvoice.GetInvoiceResponse();


            Console.WriteLine("Press enter to exit");
            Console.ReadLine();
        }

        private static void MyInvoice_InvoiceCompleted(List<InvoiceGenerator.InvoiceResponseItem> responseItems)
        {
            List<InvoiceGenerator.InvoiceResponseItem> list = new List<InvoiceGenerator.InvoiceResponseItem>(responseItems);
            foreach (InvoiceGenerator.InvoiceResponseItem item in list)
            {
                Console.WriteLine(item.ResponseStatus);
                Console.WriteLine(item.ResponseInvoiceNumber);
                Console.WriteLine(item.ResponseDataNumber);
                Console.WriteLine(item.ResponseInvoiceDate);
                Console.WriteLine(item.ResponseInvoiceTime);
                Console.WriteLine(item.ResponseRandomNumber);
                Console.WriteLine(item.ResponseInvoiceError);
            }
        }
    }
}
